(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright (c) 2013-2014 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: uhomogeneous_tuple.mli,v 1.6 2014/05/06 12:56:17 fclement Exp $ *)

open Uhomogeneous_tuple_spec;;

module Make : MAKER;;

module Single : HOMOGENEOUS_TUPLE with type 'a t = 'a;;
module Double : HOMOGENEOUS_TUPLE with type 'a t = 'a * 'a;;
module Triple : HOMOGENEOUS_TUPLE with type 'a t = 'a * 'a * 'a;;

module Vector :
  functor (V : Uvector_spec.VECTOR) ->
  HOMOGENEOUS_TUPLE with type 'a t = 'a V.t
;;
