CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                     C
C                            Pio (Fortran)                            C
C                                                                     C
C                    Polyglot Input/Output Library                    C
C                                                                     C
C               EPI Pomdapi, INRIA Paris - Rocquencourt               C
C                                                                     C
C  Copyright 2005-2014 INRIA.                                         C
C  Institut National de Recherche en Informatique et en Automatique.  C
C  All rights reserved. This file is distributed only by permission.  C
C                                                                     C
C  Francois Clement <Francois.Clement@inria.fr>                       C
C  Pierre Weis <Pierre.Weis@inria.fr>                                 C
C  Hend Ben Ameur <hbenameur@yahoo.ca>                                C
C                                                                     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C $Id: debug_mode.fpp,v 1.2 2014/01/10 19:22:10 fclement Exp $

C     
C     The debug mode implies the report mode.
C     
      
      subroutine pio_set_debug_mode
C     Turn the debug mode on.
      
      implicit none
      
      include 'debug_mode_definition.fh'
      
      pio_is_debug_mode_on = .True.
      pio_is_report_mode_on = .True.
      
      return
      end
      
      
      subroutine pio_unset_debug_mode
C     Switch the debug mode off.
      
      implicit none
      
      include 'debug_mode_definition.fh'
      
      pio_is_debug_mode_on = .False.
      
      return
      end
      
      
      logical function pio_get_debug_mode()
C     Get the debug mode.
      
      implicit none
      
      include 'debug_mode_definition.fh'
      
      pio_get_debug_mode = pio_is_debug_mode_on
      
      return
      end
      
      
      subroutine pio_set_report_mode
C     Turn the report mode on.
      
      implicit none
      
      include 'debug_mode_definition.fh'
      
      pio_is_report_mode_on = .True.
      
      return
      end
      
      
      subroutine pio_unset_report_mode
C     Switch the report mode off.
      
      implicit none
      
      include 'debug_mode_definition.fh'
      
      pio_is_report_mode_on = .False.
      pio_is_debug_mode_on = .False.
      
      return
      end
      
      
      logical function pio_get_report_mode()
C     Get the report mode.
      
      implicit none
      
      include 'debug_mode_definition.fh'
      
      pio_get_report_mode = pio_is_report_mode_on
      
      return
      end
