CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                     C
C                              Ref-indic                              C
C                                                                     C
C                        Refinement indicators                        C
C                                                                     C
C               EPI Pomdapi, INRIA Paris - Rocquencourt               C
C                                                                     C
C  Copyright (c) 2013-2014 INRIA.                                     C
C  Institut National de Recherche en Informatique et en Automatique.  C
C  All rights reserved. This file is distributed only by permission.  C
C                                                                     C
C  Hend Ben Ameur <hbenameur@yahoo.ca>                                C
C  Francois Clement <Francois.Clement@inria.fr>                       C
C  Pierre Weis <Pierre.Weis@inria.fr>                                 C
C                                                                     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C     $Id: simul.f,v 1.5 2014/05/12 14:43:23 fclement Exp $

      subroutine simul(indic, nzones, param, cout, gdcout,
     +     izs, rzs, dzs)
      
      implicit none
      
      include 'common.fh'
      
C     Input arguments.
      integer indic, nzones, izs(*)
      real rzs(*)
      real*8 param(*), dzs(*)
      
C     Output arguments.
      real*8 cout, gdcout(*)
      
C     Variables locales.
      integer i, ncells, izs_ptr, dzs_ptr, ndS, ndT
      integer proj(np_max)
      integer ijunk
      real rjunk
      real*8 S(np_max), T(np_max)
      real*8 gdS(np_max), gdT(np_max)
      real*8 djunk
      
      ijunk = izs(1)
      rjunk = rzs(1)
      djunk = dzs(1)
      
C     Get ncells, ndS, ndT, proj and S.
      ncells = izs(1)
      ndS = ncells
      ndT = ncells
      izs_ptr = 2
      dzs_ptr = 1
      do i = 1, ncells
         proj(i) = izs(izs_ptr)
         S(i) = dzs(dzs_ptr)
         izs_ptr = izs_ptr + 1
         dzs_ptr = dzs_ptr + 1
      enddo
      
      if (indic.eq.4) then
         
         call parametrisation(ncells, proj, nzones, param, T)
         
         call simu(ndS, ndT, S, T, cout)
         
         call gradient(ndS, ndT, S, T, gdS, gdT)
         
C     Projection = adjoint paramatrisation.
         call projection(ncells, proj, nzones, gdT, gdcout)
         
      end if
      
      return
      end
